module Extra :
  sig
    val head : ?n:int -> 'a list -> 'a list
    val tail : ?i:int -> 'a list -> 'a list
    val substract : 'a list -> 'a list -> 'a list
    val subset : 'a list -> 'a list -> bool
    val eqset : 'a list -> 'a list -> bool
    val intersection : 'a list -> 'a list -> 'a list
    val foreach : 'a list -> ('a -> unit) -> unit
    val uniq : 'a list -> 'a list
    val range : int -> int -> int list
    val interval : int -> int -> int list
    val indexes : 'a list -> int list
    val asFunction : int list -> int -> int
    val select : 'a list -> int list -> 'a list
    val rmindex : 'a list -> int -> 'a list
    val indexSuchThat : ('a -> bool) -> 'a list -> int option
    val indexOf : 'a -> 'a list -> int option
    val firstIndexOf : 'a -> 'a list -> int option
    val lastIndexOf : 'a -> 'a list -> int option
    val shuffle : 'a list -> 'a list
    val permute : (int -> int) -> 'a list -> 'a list
    val shuffler : 'a list -> int -> int
    val shuffleIndexes : 'a list -> int list
    val big : ('a -> 'a -> 'a) -> 'a list -> 'a
    val max : 'a list -> 'a
    val min : 'a list -> 'a
    val transpose : 'a list list -> 'a list list
  end
module List :
  sig
    val length : 'a list -> int
    val hd : 'a list -> 'a
    val tl : 'a list -> 'a list
    val nth : 'a list -> int -> 'a
    val rev : 'a list -> 'a list
    val append : 'a list -> 'a list -> 'a list
    val rev_append : 'a list -> 'a list -> 'a list
    val concat : 'a list list -> 'a list
    val flatten : 'a list list -> 'a list
    val iter : ('a -> unit) -> 'a list -> unit
    val map : ('a -> 'b) -> 'a list -> 'b list
    val rev_map : ('a -> 'b) -> 'a list -> 'b list
    val fold_left : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a
    val fold_right : ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b
    val iter2 : ('a -> 'b -> unit) -> 'a list -> 'b list -> unit
    val map2 : ('a -> 'b -> 'c) -> 'a list -> 'b list -> 'c list
    val rev_map2 : ('a -> 'b -> 'c) -> 'a list -> 'b list -> 'c list
    val fold_left2 : ('a -> 'b -> 'c -> 'a) -> 'a -> 'b list -> 'c list -> 'a
    val fold_right2 :
      ('a -> 'b -> 'c -> 'c) -> 'a list -> 'b list -> 'c -> 'c
    val for_all : ('a -> bool) -> 'a list -> bool
    val exists : ('a -> bool) -> 'a list -> bool
    val for_all2 : ('a -> 'b -> bool) -> 'a list -> 'b list -> bool
    val exists2 : ('a -> 'b -> bool) -> 'a list -> 'b list -> bool
    val mem : 'a -> 'a list -> bool
    val memq : 'a -> 'a list -> bool
    val find : ('a -> bool) -> 'a list -> 'a
    val filter : ('a -> bool) -> 'a list -> 'a list
    val find_all : ('a -> bool) -> 'a list -> 'a list
    val partition : ('a -> bool) -> 'a list -> 'a list * 'a list
    val assoc : 'a -> ('a * 'b) list -> 'b
    val assq : 'a -> ('a * 'b) list -> 'b
    val mem_assoc : 'a -> ('a * 'b) list -> bool
    val mem_assq : 'a -> ('a * 'b) list -> bool
    val remove_assoc : 'a -> ('a * 'b) list -> ('a * 'b) list
    val remove_assq : 'a -> ('a * 'b) list -> ('a * 'b) list
    val split : ('a * 'b) list -> 'a list * 'b list
    val combine : 'a list -> 'b list -> ('a * 'b) list
    val sort : ('a -> 'a -> int) -> 'a list -> 'a list
    val stable_sort : ('a -> 'a -> int) -> 'a list -> 'a list
    val fast_sort : ('a -> 'a -> int) -> 'a list -> 'a list
    val merge : ('a -> 'a -> int) -> 'a list -> 'a list -> 'a list
    val head : ?n:int -> 'a list -> 'a list
    val tail : ?i:int -> 'a list -> 'a list
    val substract : 'a list -> 'a list -> 'a list
    val subset : 'a list -> 'a list -> bool
    val eqset : 'a list -> 'a list -> bool
    val intersection : 'a list -> 'a list -> 'a list
    val foreach : 'a list -> ('a -> unit) -> unit
    val uniq : 'a list -> 'a list
    val range : int -> int -> int list
    val interval : int -> int -> int list
    val indexes : 'a list -> int list
    val asFunction : int list -> int -> int
    val select : 'a list -> int list -> 'a list
    val rmindex : 'a list -> int -> 'a list
    val indexSuchThat : ('a -> bool) -> 'a list -> int option
    val indexOf : 'a -> 'a list -> int option
    val firstIndexOf : 'a -> 'a list -> int option
    val lastIndexOf : 'a -> 'a list -> int option
    val shuffle : 'a list -> 'a list
    val permute : (int -> int) -> 'a list -> 'a list
    val shuffler : 'a list -> int -> int
    val shuffleIndexes : 'a list -> int list
    val big : ('a -> 'a -> 'a) -> 'a list -> 'a
    val max : 'a list -> 'a
    val min : 'a list -> 'a
    val transpose : 'a list list -> 'a list list
  end
